<template>
  <div id="app">
    <div class="wrapper">
      <div class="chat-list">
        <img src="./assets/img/chat_list.svg" alt="background-chatlist" />
      </div>
      <div class="chat-data-wrapper">
        <div class="chat">
          <img src="./assets/img/chat.svg" alt="background-chat" />
          <div class='sticker-preview-wrapper'>
            <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABAQMAAAAl21bKAAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAAApJREFUCNdjYAAAAAIAAeIhvDMAAAAASUVORK5CYII=" alt="sticker-preview" class="sticker-preview">
          </div>
        </div>

        <!-- 4. Declare tag to be used as MJTMainView, MJTRTSView Component -->
        <!-- 4. MJTMainView, MJTRTSView Component로 이용될 태그 선언 -->
        <div class="input-view-wrapper">
          <button id="emojiBtn" class="main-view-btn">😀</button>
          <div class="rts-view-wrapper">
            <div class="mjt-rts-view">
              <div id="mojitokRTSView"></div>
            </div>
            <div class="input-wrapper">
              <textarea
                id="textInput"
                class="input"
                placeholder="Enter Text"
                colum="2"
              ></textarea>
            </div>
          </div>
        </div>
      </div>

      <div class="mjt-main-view-wrapper">
        <div id="mojitokMainView"></div>
      </div>
    </div>
  </div>
</template>

<script>
// 2. Import React DOM
// 2. React DOM 추가
import React from "react";
import ReactDOM from "react-dom";

// 3. Import UIKit component
// 3. UIKit 구성 요소 import
import { MJTMainView, MJTRTSView, Mojitok } from "@mojitok/mojitok-uikit";
import "@mojitok/mojitok-uikit/dist/index.css";

function init() {
  let isShowMjtMainView = false;

  // 5-1. Initiallize Mojitok module
  // 5-1. Mojitok 모듈 초기화
  Mojitok.setup(
    '{YOUR-APP-ID}', // Application ID
  );

  // 5-2. Choose one of our payment platforms, currently “EXIMBAY” is supported, will be expanded later.
  // 5-2. 결제 플랫폼 선택. 현재 "EXIMBAY" 만 지원되며 추후 지원 플랫폼을 추가할 계획입니다.
  Mojitok.setPaymentPlatform("EXIMBAY");

  // 5-3. Set position and size of store web popup.
  // 5-3. 스토어 웹 팝업의 위치와 크기 설정
  Mojitok.setStoreGeometry(/* {POS-LEFT} */0, /* {POS-TOP} */0, /* {SIZE-WIDTH} */360, /* {SIZE-HEIGHT} */640); // Position and size of store web popup

  // 6. Mojitok module login (async(recommended) example, synchronous implementation is also possible)
  // 6. Mojitok 모듈 로그인 (비동기(권장) 예시이며, 동기 구현도 가능합니다)
  Mojitok.login(
    '{YOUR-APP-TOKEN}', // Application Token
    '{YOUR-APP-USER-ID}', //
    (e) => {
      if (e == null) {
        // 6-a. on Success
        // 6-a. 성공 시
      } else {
        // 6-b. on Fail: If the e.code value is 4001, then please check the applicationId or the applicationToken
        // 6-b. 실패 시: e.code 값이 4001이라면 applicationId 또는 Token을 확인해주세요
      }
    }
  );

  // 7. Write <choice> Callback function to be used for MJTMainView, MJTRTSView
  // 7. MJTMainView, MJTRTSView 에 사용할 <선택> Callback 함수 작성
  const handleStickerChoice = (mjtStickerInfo) => {
    const stickerPreviewElem = document.querySelector(".sticker-preview");
    stickerPreviewElem.setAttribute('src', mjtStickerInfo.url);
  };

  const inputElem = document.querySelector("#textInput");

  // 8. Add MJTRTSView Component
  // 8. MJTRTSView Component 추가
  const rtsView = document.getElementById("mojitokRTSView");

  inputElem.addEventListener("input", (e) => {
    ReactDOM.render(
      React.createElement(MJTRTSView, {
        width: "inherit",
        height: "64px",
        text: e.target.value,
        onStickerChoice: handleStickerChoice,
      }),
      rtsView
    );
  });

  if (isShowMjtMainView) {
    inputElem.classList.add("main-view-show-input");
  } else {
    inputElem.classList.remove("main-view-show-input");
  }

  const emjBtnElem = document.getElementById("emojiBtn");

  // 9. Add MJTMainView Component
  // 9. MJTMainView Component 추가
  const mainView = document.getElementById("mojitokMainView");
  ReactDOM.render(
    React.createElement(MJTMainView, {
      width: "350px",
      height: "300px",
      onStickerChoice: handleStickerChoice,
    }),
    mainView
  );

  emjBtnElem.addEventListener("click", (e) => {
    isShowMjtMainView = !isShowMjtMainView;

    if (isShowMjtMainView) {
      console.log(emjBtnElem);
      emjBtnElem.classList.add("main-view-btn-selected");
      mainView.classList.add("display-view");
    } else {
      emjBtnElem.classList.remove("main-view-btn-selected");
      mainView.classList.remove("display-view");
    }
  });
}

export default {
  name: "App",
  components: {},
  mounted() {
    init();
  },
};
</script>

<!-- 1. import index.css -->
<!-- 1. index.css 추가 -->
<style src="./index.css"></style>
